// This file is part of Ghost Network.

// Ghost Network is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Ghost Network is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Ghost Network.  If not, see <http://www.gnu.org/licenses/>.

//! Autogenerated weights for `ghost_networks`
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 32.0.0
//! DATE: 2025-06-19, STEPS: `50`, REPEAT: `20`, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! WORST CASE MAP SIZE: `1000000`
//! HOSTNAME: `ghostown`, CPU: `Intel(R) Core(TM) i3-2310M CPU @ 2.10GHz`
//! WASM-EXECUTION: `Compiled`, CHAIN: `Some("casper-dev")`, DB CACHE: 1024

// Executed Command:
// ./target/release/ghost
// benchmark
// pallet
// --chain=casper-dev
// --steps=50
// --repeat=20
// --pallet=ghost_networks
// --extrinsic=*
// --wasm-execution=compiled
// --heap-pages=4096
// --header=./file_header.txt
// --output=./runtime/casper/src/weights/ghost_networks.rs

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]

use frame_support::{
    traits::Get, 
    weights::{
        Weight, constants::RocksDbWeight
    }
};
use sp_std::marker::PhantomData;

/// Weight functions needed for ghost_networks
pub trait WeightInfo {
	fn register_network(n: u32, m: u32, ) -> Weight;
	fn update_network_name(n: u32, ) -> Weight;
	fn update_network_endpoint(n: u32, ) -> Weight;
	fn update_network_finality_delay() -> Weight;
    fn update_network_rate_limit_delay() -> Weight;
	fn update_network_block_distance() -> Weight;
	fn update_network_type() -> Weight;
	fn update_network_gatekeeper() -> Weight;
	fn update_network_topic_name() -> Weight;
	fn update_incoming_network_fee() -> Weight;
	fn update_outgoing_network_fee() -> Weight;
	fn remove_network() -> Weight;
}

/// Weight for ghost_networks using the Substrate node and recommended hardware.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> WeightInfo for SubstrateWeight<T> {
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `i` is `[1, 20]`.
	/// The range of component `j` is `[1, 150]`.
	fn register_network(_i: u32, j: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `109`
		//  Estimated: `3574`
		// Minimum execution time: 43_753_000 picoseconds.
		Weight::from_parts(45_805_520, 0)
			.saturating_add(Weight::from_parts(0, 3574))
			// Standard Error: 412
			.saturating_add(Weight::from_parts(1_586, 0).saturating_mul(j.into()))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `n` is `[1, 20]`.
	fn update_network_name(n: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 49_412_000 picoseconds.
		Weight::from_parts(50_617_210, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			// Standard Error: 3_074
			.saturating_add(Weight::from_parts(6_017, 0).saturating_mul(n.into()))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `n` is `[1, 150]`.
	fn update_network_endpoint(n: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 49_485_000 picoseconds.
		Weight::from_parts(50_716_057, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			// Standard Error: 453
			.saturating_add(Weight::from_parts(4_916, 0).saturating_mul(n.into()))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_finality_delay() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_061_000 picoseconds.
		Weight::from_parts(49_072_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_rate_limit_delay() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 49_066_000 picoseconds.
		Weight::from_parts(52_137_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_block_distance() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_085_000 picoseconds.
		Weight::from_parts(48_838_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_type() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 47_872_000 picoseconds.
		Weight::from_parts(48_972_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_gatekeeper() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 50_029_000 picoseconds.
		Weight::from_parts(50_768_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_topic_name() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 50_151_000 picoseconds.
		Weight::from_parts(51_573_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_incoming_network_fee() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_017_000 picoseconds.
		Weight::from_parts(49_513_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_outgoing_network_fee() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_714_000 picoseconds.
		Weight::from_parts(49_777_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn remove_network() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 44_583_000 picoseconds.
		Weight::from_parts(45_681_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
}

impl WeightInfo for () {
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `i` is `[1, 20]`.
	/// The range of component `j` is `[1, 150]`.
	fn register_network(_i: u32, j: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `109`
		//  Estimated: `3574`
		// Minimum execution time: 43_753_000 picoseconds.
		Weight::from_parts(45_805_520, 0)
			.saturating_add(Weight::from_parts(0, 3574))
			// Standard Error: 412
			.saturating_add(Weight::from_parts(1_586, 0).saturating_mul(j.into()))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `n` is `[1, 20]`.
	fn update_network_name(n: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 49_412_000 picoseconds.
		Weight::from_parts(50_617_210, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			// Standard Error: 3_074
			.saturating_add(Weight::from_parts(6_017, 0).saturating_mul(n.into()))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `n` is `[1, 150]`.
	fn update_network_endpoint(n: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 49_485_000 picoseconds.
		Weight::from_parts(50_716_057, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			// Standard Error: 453
			.saturating_add(Weight::from_parts(4_916, 0).saturating_mul(n.into()))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_finality_delay() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_061_000 picoseconds.
		Weight::from_parts(49_072_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_rate_limit_delay() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 49_066_000 picoseconds.
		Weight::from_parts(52_137_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_block_distance() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_085_000 picoseconds.
		Weight::from_parts(48_838_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_type() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 47_872_000 picoseconds.
		Weight::from_parts(48_972_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_gatekeeper() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 50_029_000 picoseconds.
		Weight::from_parts(50_768_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_network_topic_name() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 50_151_000 picoseconds.
		Weight::from_parts(51_573_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_incoming_network_fee() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_017_000 picoseconds.
		Weight::from_parts(49_513_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn update_outgoing_network_fee() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 48_714_000 picoseconds.
		Weight::from_parts(49_777_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
	/// Storage: `GhostNetworks::Networks` (r:1 w:1)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn remove_network() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `301`
		//  Estimated: `3766`
		// Minimum execution time: 44_583_000 picoseconds.
		Weight::from_parts(45_681_000, 0)
			.saturating_add(Weight::from_parts(0, 3766))
			.saturating_add(RocksDbWeight::get().reads(1))
			.saturating_add(RocksDbWeight::get().writes(1))
	}
}
